*+
*+
*+    Source Module => FLDREN.PRG
*+
*+    Functions: Function fieldRename()
*+
*+    Reformatted by Click! 2.01 on Dec-31-1998 at  9:31 pm
*+
*+

/*
WARNING : USE AT YOUR OWN RISK
          TESTED FOR CLIPPER/dBASE/FOXPRO FILES CREATED THROUGH CLIPPER RDDs
Function fieldRename
Purpose    : Renames Field(s) of Clipper .DBF (Works Fine For Me)
Parameters : cDBF    : File Name including absolute path and extension
             cOldFieldName
             cNewFieldName
Returns    : Success
*
AUTHOR : NITIN C. CHAUHAN
DATED  : 16 DEC 1998
*/

*+
*+
*+    Function fieldRename()
*+
*+
*+
function fieldRename( cDBF, cOldFieldName, cNewFieldName )

local lSuccess := .F.
local nPos     := 0                     // Field Position
local cBuffer                           // Buffer
local nFBSize  := 32                    // Field Block Size
local aFlds    := {}                    // Holds List of Filelds
local nHandle  := fopen( cDBF, 2 )

if nHandle # - 1

   // Skip Header information 32 bytes
   fseek( nHandle, 32, 0 )

   do while nFBSize = 32

      cBuffer := space( nFBSize )
      nFBSize := fread( nHandle, @cBuffer, nFBSize )

      // Not checking for read bytes
      if substr( cBuffer, 1, 1 ) = chr( 13 )

         // End of fields information, Data offset starts
         exit

      endif

      // Add Field Name into Lookup array
      aadd( aFlds, ;
            padr( substr( substr( cBuffer, 1, 11 ), 1, ;
            at( chr( 0 ), substr( cBuffer, 1, 11 ) ) - 1 ), 10 ) )
   enddo

   nPos := ascan( aFlds, padr( upper( cOldFieldName ), 10 ) )

   if nPos > 0

      // Move to Position of the Old Field Name
      fseek( nHandle, nPos * 32, 0 )

      // Cool
      fwrite( nHandle, padr( upper( cNewFieldName ), 10 ) + chr( 0 ), 11 )
      lSuccess := .T.

   endif

   fclose( nHandle )

endif

return lSuccess

*+ EOF: FLDREN.PRG
